<template>
  <div id="show_wallet" class="createPost-container">
    <el-row style="margin-bottom: 20px;padding-bottom: 20px;border-bottom: 1px solid #eee">
      <el-col :span="2" class="line">
        {{ $t('row.title') }}:
      </el-col>
      <el-col :span="4">
        {{ Wallet.title }}
      </el-col>
      <el-col :span="1">
        &nbsp;
      </el-col>
      <el-col :span="2" class="line">
        {{ $t('row.address') }}:
      </el-col>
      <el-col :span="4">
        {{ Wallet.address }}
      </el-col>
      <el-col :span="1">
        &nbsp;
      </el-col>
      <el-col :span="2" class="line">
        {{ $t('form.explain') }}:
      </el-col>
      <el-col :span="6">
        {{ Wallet.explain }}
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="Tokens_Wallets">
      <el-table-column prop="title" :label=" $t('form.title') + ' ' + $t('row.token') " align="center" />
      <el-table-column prop="amount" :label=" $t('row.amount') " align="center" />
      <el-table-column prop="explain" :label=" $t('form.explain') " align="center" />
      <el-table-column prop="status" :label=" $t('row.status') " align="center">
        <template slot-scope="scope">
          {{ $t('row.' + scope.row.status) }}
        </template>
      </el-table-column>
      <el-table-column prop="operation" :label=" $t('row.operation') " align="center">
        <template slot-scope="scope">
          <router-link v-if=" scope.row.status == 'ok'" :to="'/wallet/transmit-token/' + scope.row.id + '&' +scope.row.twid" :title=" $t('row.transmit') ">
            <span v-if=" scope.row.status == 'ok'" class="el-icon-more green pointer" :title=" $t('row.transmit') ">&nbsp;</span>
          </router-link>
          <span v-if=" scope.row.status == 'checking'" class="el-icon-delete green pointer" :title=" $t('row.remove') " @click="removeToken(scope.row.twid);">&nbsp;</span>
        </template>
      </el-table-column>
    </el-table>
    <el-form ref="postForm" :model="postForm" class="form-container" style="width: 100%;margin-top: 20px;padding-top: 20px;border-top: 1px solid #eee">
      <el-row>
        <el-col :span="4" class="line" style="line-height: 35px">
          {{ $t('form.select_token') }}
        </el-col>
        <el-col :span="7">
          <el-form-item>
            <el-select v-model="postForm.token_id" :placeholder=" $t('form.select_token') " required>
              <el-option v-for="item in Tokens" :key="item.id" :label="item.title" :value="item.id" />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="4" class="line" style="line-height: 35px">
          {{ $t('form.num_token') }}
        </el-col>
        <el-col :span="7">
          <el-form-item>
            <el-input v-model="postForm.amount" type="text" required />
            <el-input v-model="postForm.wallet_id" type="hidden" required />
          </el-form-item>
        </el-col>
        <el-col :span="1">
          &nbsp;
        </el-col>
        <el-col :span="1">
          <el-form-item>
            <el-button type="primary" @click="submitForm">
              {{ $t('form.submit') }}
            </el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
  </div>
</template>

<script>
import Wallet from '@/api/task';
const walletResource = new Wallet('wallets');

import Vue from 'vue';
import 'vuejs-dialog/dist/vuejs-dialog.min.css';
import VuejsDialog from 'vuejs-dialog';

export default {
  name: 'WalletShow',
  components: { },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    Vue.use(VuejsDialog, {
      html: true,
      loader: true,
      okText: this.$t('dialog.confirm'),
      cancelText: this.$t('dialog.cancel'),
      animation: 'bounce',
    });
    const validateRequire = (rule, value, callback) => {
      if (value === '') {
        this.$message({
          message: rule.field + ' is required',
          type: 'error',
        });
        callback(new Error(rule.field + ' is required'));
      } else {
        callback();
      }
    };
    return {
      loading: true,
      postForm: {
        amount: '',
        token_id: '',
        wallet_id: '',
      },
      rules: {
        token_id: [{ validator: validateRequire }],
        amount: [{ validator: validateRequire }],
      },
      Tokens: [],
      removeTokenOperation: {
        id: '',
      },
      Tokens_Wallets: [],
      Wallet: [],
    };
  },
  created() {
    const id = this.$route.params && this.$route.params.id;
    this.fetchData(id);
  },
  methods: {
    transmitToken(id) {},
    removeToken(id) {
      this.$dialog
        .confirm(this.$t('dialog.confirmDelete'), {
          loader: true,
        })
        .then(dialog => {
          this.removeTokenOperation.id = id;
          walletResource.removeToken(this.removeTokenOperation)
            .then(response => {})
            .catch(err => {
              console.log(err);
            });
          setTimeout(() => {
            this.fetchTokens(this.postForm.wallet_id);
            dialog.close();
          }, 1000);
        })
        .catch(() => {
        });
    },
    fetchData(id) {
      walletResource.show(id)
        .then(response => {
          this.Tokens = response.Token;
          this.Wallet = response.Wallet;
          this.postForm.wallet_id = response.Wallet.id;
          this.loading = true;
          this.fetchTokens(response.Wallet.id);
        })
        .catch(err => {
          console.log(err);
        });
    },
    fetchTokens(id) {
      walletResource.fetchTokens(id)
        .then(response => {
          this.Tokens_Wallets = response.tokens;
          this.loading = false;
        })
        .catch(err => {
          console.log(err);
        });
    },
    submitForm() {
      console.log(this.postForm);
      this.$refs.postForm.validate(valid => {
        if (valid) {
          this.loading = true;
          walletResource
            .addToken(this.postForm)
            .then(response => {
              this.fetchTokens(this.postForm.wallet_id);
              this.$message({
                message: 'Token has been added successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
  },
};
</script>

<style scoped>
.edit-input {
  padding-right: 100px;
}
.cancel-btn {
  position: absolute;
  right: 15px;
  top: 10px;
}
</style>
